(function (root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define([], factory);
    } else if (typeof module === 'object' && module.exports) {
        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = factory();
    } else {
        // Browser globals (root is window)
        root.returnExports = factory();
  }
}(typeof self !== 'undefined' ? self : this, function () {
    function SadError(selector)
    {
        this.selector=selector;
    }

    SadError.prototype.open = function(exception)
    {

    }
 
    function Sad()
    {
        this.current = null;
        this.selector = 'body';
        this.events = {};
        events['beforeadd'] = [];
        events['afteradd'] = [];
        events['beforenavigate'] = [];
        events['navigate'] = [];        
        events['afternavigate'] = [];
        this.addScreen("/saderror", SadError);
        window.onerror = function(msg, file, line, col,err)
        {
    
            self.navigate("/saderror", {msg:msg,file:file,line:line,col:col,err:err});
        }
    }
   
    Sad.prototype.navigate = function(urlstring, params)
    {
        
        if(!params)
            params={};
        var url = this.parse(urlstring,params);

        if(!this.fire('beforenavigate', url, params))
            return false;

        if(!this.closeCurrent(url, params))
            return false;

        this.current = new screenClass[url](this.selector);

        this.fire('navigate', url, params);

        if(this.current.open)
            this.current.open(url, params);

        this.fire('afternavigate', url, params);            
    }

    
    Sad.prototype.parse = function(urlstring,params)
    {
        params._urlstring = urlstring;
        var qsplit = urlstring.split('?');
        params._url = qsplit[0];
        if(qsplit[1])
        {
            psplit = qsplit.split('&');
            for(var i = 0;i < pslit.length;i++)
            {
                kvsplit = pslit.split('=');
                var key = kvsplit[0];
                var val = kvsplit[1];
                params[key] = value;
            }
        }
    }
    
    Sad.prototype.addScreen = function (url, screenClass)
    {
        this.screenClass[url] = screenClass;
    }
 
    Sad.prototype.closeCurrent = function(url, parameters)
    {
        if(this.current !== null && this.current.close)
        {
            var result = this.current.close(url, parameters);
            if(result === false)
                return false;
            this.current = null;
            return true;
        }
    }

    Sad.prototype.on = function(name, handler)
    {
        var event = validEvent(name);
        event.add(handler);
    }

    Sad.prototype.off = function(handler)
    {
        var event = validEvent(name);
        for(var i = event.length - 1;i >=0;i--)
        {
            if(handler == event[i])
                event.splice(i,1);
        }
    }

    Sad.prototype.fire = function(name)
    {
        var event = validEvent(name);
        var ok = true;
        for(var i = 0;i < event.length;i++)
        {
            if(!event[i](args))
                ok = false;
        }
        return ok;
    }

    Sad.prototype.validEvent = function(name)
    {
        var event = this.events[name];
        if(event = null)
            throw new Error(name + ' is not a valid event');
    }
          

    function SadBrowser(sad)
    {
        this.sad = sad;
        var self = this;
        sad.on('navigate',function(url, params){
            self.update(params._sad.urlstring)
        });
        window.addEventListener("hashchange", function(event)
        {
            self.hashchange(event);
        });
    }

    SadBrowser.prototype.addresshashchange = function(event)
    {
        var urlstring = window.location.hash + '';
        this.sad.navigate(urlstring);
    }

    SadBrowser.prototype.addresschangehash = function(urlstring)
    {
        var urlstring = window.location.hash + '';
        this.sad.navigate(urlstring);
        if(window.location.hash != urlstring)
        {
            var url = window.location.href.split['#'];
            window.pushState(url + '#' + urlstring);
        }
    }
   
    SadBrowser.prototype.scroll = function(position)
    {
        
    }

    return Sad;
}));
